#include <bits/stdc++.h>
#define ll long long
#define fi first
#define se second
using namespace std;

int main(){
    ios_base::sync_with_stdio(false),cin.tie(0),cout.tie(0);
    ll n,q;
    ll uk=0, trD=0, trV=0, m=0;
    cin>>n>>q;
    vector<pair<ll, ll>> k(n);
    for(ll i=0; i<n; i++){
        cin>>k[i].fi>>k[i].se;
    }
    vector<ll> a(q);
    for(ll i=0; i<q; i++){
        cin>>a[i];
    }
    vector<ll> rez(q);
    for(ll i=0; i<q; i++){
        ll kraj=a[i];
        while(m<n && k[m].fi<=kraj){
            ll raz=k[m].fi-trD;
            ll poj=min(trV,raz);
            uk+=poj;
            trV+=k[m].se-poj;
            trD=k[m].fi;
            m++;
        }

        if (trD<=kraj){
            ll raz=kraj-trD+1;
            ll poj=min(trV,raz);
            uk+=poj;
            trV-=poj;
            trD=kraj+1;
        }
        rez[i]=uk;
    }
    for(ll i=0; i<q; i++){
        cout<<rez[i]<<endl;
    }
    return 0;
}